Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkStreamer Class Reference

`#include <vtkStreamer.h>`

Inheritance diagram for vtkStreamer:

[legend]
Collaboration diagram for vtkStreamer:

[legend]
List of all members.

## Detailed Description

abstract object implements integration of massless particle through vector field

Date:
  2002/11/12 20:06:05

Revision:
  1.60

vtkStreamer is a filter that integrates a massless particle through a vector field. The integration is performed using second order Runge-Kutta method. vtkStreamer often serves as a base class for other classes that perform numerical integration through a vector field (e.g., vtkStreamLine).

Note that vtkStreamer can integrate both forward and backward in time, or in both directions. The length of the streamer is controlled by specifying an elapsed time. (The elapsed time is the time each particle travels.) Otherwise, the integration terminates after exiting the dataset or if the particle speed is reduced to a value less than the terminal speed.

vtkStreamer integrates through any type of dataset. As a result, if the dataset contains 2D cells such as polygons or triangles, the integration is constrained to lie on the surface defined by the 2D cells.

The starting point of streamers may be defined in three different ways. Starting from global x-y-z "position" allows you to start a single streamer at a specified x-y-z coordinate. Starting from "location" allows you to start at a specified cell, subId, and parametric coordinate. Finally, you may specify a source object to start multiple streamers. If you start streamers using a source object, for each point in the source that is inside the dataset a streamer is created.

vtkStreamer implements the integration process in the Integrate() method. Because vtkStreamer does not implement the Execute() method that its superclass (i.e., Filter) requires, it is an abstract class. Its subclasses implement the execute method and use the Integrate() method, and then build their own representation of the integration path (i.e., lines, dashed lines, points, etc.).

See also:
  vtkStreamLine vtkDashedStreamLine vtkStreamPoints

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (34%)
  - Geveci, Berk (28%)
  - Avila, Lisa (12%)
  - Lorensen, Bill (6%)
  - Barre, Sebastien (5%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkStreamer.h)`
  - .`cxx` (`/Graphics/vtkStreamer.cxx)`

Definition at line 82 of file vtkStreamer.h.

## Public Types
typedef vtkDataSetToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetStartLocation (vtkIdType cellId, int subId, float pcoords[3])
vtkIdType | GetStartLocation (int &subId, float pcoords[3])
void | SetStartPosition (float x[3])
void | SetStartPosition (float x, float y, float z)
float * | GetStartPosition ()
virtual void | SetNumberOfThreads (int)
virtual int | GetNumberOfThreads ()
virtual void | SetSavePointInterval (float)
virtual float | GetSavePointInterval ()
void | SetStartLocation (vtkIdType cellId, int subId, float r, float s, float t)
void | SetSource (vtkDataSet *source)
vtkDataSet * | GetSource ()
virtual void | SetMaximumPropagationTime (float)
virtual float | GetMaximumPropagationTime ()
virtual void | SetIntegrationDirection (int)
virtual int | GetIntegrationDirection ()
void | SetIntegrationDirectionToForward ()
void | SetIntegrationDirectionToBackward ()
void | SetIntegrationDirectionToIntegrateBothDirections ()
const char * | GetIntegrationDirectionAsString ()
virtual void | SetIntegrationStepLength (float)
virtual float | GetIntegrationStepLength ()
virtual void | SetSpeedScalars (int)
virtual int | GetSpeedScalars ()
virtual void | SpeedScalarsOn ()
virtual void | SpeedScalarsOff ()
virtual void | SetOrientationScalars (int)
virtual int | GetOrientationScalars ()
virtual void | OrientationScalarsOn ()
virtual void | OrientationScalarsOff ()
virtual void | SetTerminalSpeed (float)
virtual float | GetTerminalSpeed ()
virtual void | SetVorticity (int)
virtual int | GetVorticity ()
virtual void | VorticityOn ()
virtual void | VorticityOff ()
void | SetIntegrator (vtkInitialValueProblemSolver *)
virtual vtkInitialValueProblemSolver * | GetIntegrator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkStreamer * | SafeDownCast (vtkObject *o)
## Protected Methods
void | Integrate ()
void | ComputeVorticity ()
void | InitializeThreadedIntegrate ()
| vtkStreamer ()
| ~vtkStreamer ()
virtual int | GetNumberOfStreamers ()
StreamArray * | GetStreamers ()
## Static Protected Methods
VTK_THREAD_RETURN_TYPE | ThreadedIntegrate (void *arg)
## Protected Attributes
int | StartFrom
vtkIdType | StartCell
int | StartSubId
float | StartPCoords [3]
float | StartPosition [3]
StreamArray * | Streamers
vtkIdType | NumberOfStreamers
float | MaximumPropagationTime
int | IntegrationDirection
float | IntegrationStepLength
int | Vorticity
float | TerminalSpeed
int | SpeedScalars
int | OrientationScalars
vtkInitialValueProblemSolver * | Integrator
float | SavePointInterval
vtkMultiThreader * | Threader
int | NumberOfThreads
## Friends
class | StreamArray

## Member Typedef Documentation

typedef vtkDataSetToPolyDataFilter vtkStreamer::Superclass

| Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints. Definition at line 85 of file vtkStreamer.h.

## Constructor & Destructor Documentation

vtkStreamer::vtkStreamer | ( |  | ) | `[protected]`

| Construct object to start from position (0,0,0); integrate forward; terminal speed 0.0; vorticity computation off; integrations step length 0.2; and maximum propagation time 100.0.

vtkStreamer::~vtkStreamer | ( |  | ) | `[protected]`

| Construct object to start from position (0,0,0); integrate forward; terminal speed 0.0; vorticity computation off; integrations step length 0.2; and maximum propagation time 100.0.

## Member Function Documentation

virtual const char* vtkStreamer::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints.

int vtkStreamer::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints.

virtual int vtkStreamer::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints.

vtkStreamer* vtkStreamer::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints.

void vtkStreamer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataSetToPolyDataFilter. Reimplemented in vtkDashedStreamLine, vtkStreamLine, and vtkStreamPoints.

void vtkStreamer::SetStartLocation | ( | vtkIdType | cellId,
|  | int | subId,
|  | float | pcoords[3]
| ) |

| Specify the start of the streamline in the cell coordinate system. That is, cellId and subId (if composite cell), and parametric coordinates.

void vtkStreamer::SetStartLocation | ( | vtkIdType | cellId,
|  | int | subId,
|  | float | r,
|  | float | s,
|  | float | t
| ) |

| Specify the start of the streamline in the cell coordinate system. That is, cellId and subId (if composite cell), and parametric coordinates.

vtkIdType vtkStreamer::GetStartLocation | ( | int & | subId,
|  | float | pcoords[3]
| ) |

| Get the starting location of the streamline in the cell coordinate system.

void vtkStreamer::SetStartPosition | ( | float | x[3] | ) |

| Specify the start of the streamline in the global coordinate system. Search must be performed to find initial cell to start integration from.

void vtkStreamer::SetStartPosition | ( | float | x,
|  | float | y,
|  | float | z
| ) |

| Specify the start of the streamline in the global coordinate system. Search must be performed to find initial cell to start integration from.

float* vtkStreamer::GetStartPosition | ( |  | ) |

| Get the start position in global x-y-z coordinates.

void vtkStreamer::SetSource | ( | vtkDataSet * | source | ) |

| Specify the source object used to generate starting points.

vtkDataSet* vtkStreamer::GetSource | ( |  | ) |

| Specify the source object used to generate starting points.

virtual void vtkStreamer::SetMaximumPropagationTime | ( | float |  | ) | `[virtual]`

| Specify the maximum length of the Streamer expressed in elapsed time.

virtual float vtkStreamer::GetMaximumPropagationTime | ( |  | ) | `[virtual]`

| Specify the maximum length of the Streamer expressed in elapsed time.

virtual void vtkStreamer::SetIntegrationDirection | ( | int |  | ) | `[virtual]`

| Specify the direction in which to integrate the Streamer.

virtual int vtkStreamer::GetIntegrationDirection | ( |  | ) | `[virtual]`

| Specify the direction in which to integrate the Streamer.

void vtkStreamer::SetIntegrationDirectionToForward | ( |  | ) | `[inline]`

| Specify the direction in which to integrate the Streamer. Definition at line 135 of file vtkStreamer.h. References VTK_INTEGRATE_FORWARD.

void vtkStreamer::SetIntegrationDirectionToBackward | ( |  | ) | `[inline]`

| Specify the direction in which to integrate the Streamer. Definition at line 137 of file vtkStreamer.h. References VTK_INTEGRATE_BACKWARD.

void vtkStreamer::SetIntegrationDirectionToIntegrateBothDirections | ( |  | ) | `[inline]`

| Specify the direction in which to integrate the Streamer. Definition at line 139 of file vtkStreamer.h. References VTK_INTEGRATE_BOTH_DIRECTIONS.

const char * vtkStreamer::GetIntegrationDirectionAsString | ( | void |  | ) | `[inline]`

| Return the integration direction as a character string. Definition at line 335 of file vtkStreamer.h. References IntegrationDirection, VTK_INTEGRATE_BACKWARD, and VTK_INTEGRATE_FORWARD.

virtual void vtkStreamer::SetIntegrationStepLength | ( | float |  | ) | `[virtual]`

| Specify a nominal integration step size (expressed as a fraction of the size of each cell). This value can be larger than 1.

virtual float vtkStreamer::GetIntegrationStepLength | ( |  | ) | `[virtual]`

| Specify a nominal integration step size (expressed as a fraction of the size of each cell). This value can be larger than 1.

virtual void vtkStreamer::SetSpeedScalars | ( | int |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from velocity magnitude. If off, and input dataset has scalars, input dataset scalars are used.

virtual int vtkStreamer::GetSpeedScalars | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from velocity magnitude. If off, and input dataset has scalars, input dataset scalars are used.

virtual void vtkStreamer::SpeedScalarsOn | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from velocity magnitude. If off, and input dataset has scalars, input dataset scalars are used.

virtual void vtkStreamer::SpeedScalarsOff | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from velocity magnitude. If off, and input dataset has scalars, input dataset scalars are used.

virtual void vtkStreamer::SetOrientationScalars | ( | int |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from vorticity information. The scalar information is currently the orientation value "theta" used in rotating stream tubes. If off, and input dataset has scalars, then input dataset scalars are used, unless SpeedScalars is also on. SpeedScalars takes precedence over OrientationScalars.

virtual int vtkStreamer::GetOrientationScalars | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from vorticity information. The scalar information is currently the orientation value "theta" used in rotating stream tubes. If off, and input dataset has scalars, then input dataset scalars are used, unless SpeedScalars is also on. SpeedScalars takes precedence over OrientationScalars.

virtual void vtkStreamer::OrientationScalarsOn | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from vorticity information. The scalar information is currently the orientation value "theta" used in rotating stream tubes. If off, and input dataset has scalars, then input dataset scalars are used, unless SpeedScalars is also on. SpeedScalars takes precedence over OrientationScalars.

virtual void vtkStreamer::OrientationScalarsOff | ( |  | ) | `[virtual]`

| Turn on/off the creation of scalar data from vorticity information. The scalar information is currently the orientation value "theta" used in rotating stream tubes. If off, and input dataset has scalars, then input dataset scalars are used, unless SpeedScalars is also on. SpeedScalars takes precedence over OrientationScalars.

virtual void vtkStreamer::SetTerminalSpeed | ( | float |  | ) | `[virtual]`

| Set/get terminal speed (i.e., speed is velocity magnitude). Terminal speed is speed at which streamer will terminate propagation.

virtual float vtkStreamer::GetTerminalSpeed | ( |  | ) | `[virtual]`

| Set/get terminal speed (i.e., speed is velocity magnitude). Terminal speed is speed at which streamer will terminate propagation.

virtual void vtkStreamer::SetVorticity | ( | int |  | ) | `[virtual]`

| Turn on/off the computation of vorticity. Vorticity is an indication of the rotation of the flow. In combination with vtkStreamLine and vtkTubeFilter can be used to create rotated tubes. If vorticity is turned on, in the output, the velocity vectors are replaced by vorticity vectors.

virtual int vtkStreamer::GetVorticity | ( |  | ) | `[virtual]`

| Turn on/off the computation of vorticity. Vorticity is an indication of the rotation of the flow. In combination with vtkStreamLine and vtkTubeFilter can be used to create rotated tubes. If vorticity is turned on, in the output, the velocity vectors are replaced by vorticity vectors.

virtual void vtkStreamer::VorticityOn | ( |  | ) | `[virtual]`

| Turn on/off the computation of vorticity. Vorticity is an indication of the rotation of the flow. In combination with vtkStreamLine and vtkTubeFilter can be used to create rotated tubes. If vorticity is turned on, in the output, the velocity vectors are replaced by vorticity vectors.

virtual void vtkStreamer::VorticityOff | ( |  | ) | `[virtual]`

| Turn on/off the computation of vorticity. Vorticity is an indication of the rotation of the flow. In combination with vtkStreamLine and vtkTubeFilter can be used to create rotated tubes. If vorticity is turned on, in the output, the velocity vectors are replaced by vorticity vectors.

virtual void vtkStreamer::SetNumberOfThreads | ( | int |  | ) | `[virtual]`

virtual int vtkStreamer::GetNumberOfThreads | ( |  | ) | `[virtual]`

virtual void vtkStreamer::SetSavePointInterval | ( | float |  | ) | `[virtual]`

virtual float vtkStreamer::GetSavePointInterval | ( |  | ) | `[virtual]`

void vtkStreamer::SetIntegrator | ( | vtkInitialValueProblemSolver * |  | ) |

| Set/get the integrator type to be used in the stream line calculation. The object passed is not actually used but is cloned with NewInstance by each thread/process in the process of integration (prototype pattern). The default is 2nd order Runge Kutta.

virtual vtkInitialValueProblemSolver* vtkStreamer::GetIntegrator | ( |  | ) | `[virtual]`

| Set/get the integrator type to be used in the stream line calculation. The object passed is not actually used but is cloned with NewInstance by each thread/process in the process of integration (prototype pattern). The default is 2nd order Runge Kutta.

void vtkStreamer::Integrate | ( |  | ) | `[protected]`

void vtkStreamer::ComputeVorticity | ( |  | ) | `[protected]`

VTK_THREAD_RETURN_TYPE vtkStreamer::ThreadedIntegrate | ( | void * | arg | ) | `[static, protected]`

virtual int vtkStreamer::GetNumberOfStreamers | ( |  | ) | `[protected, virtual]`

| These methods were added to allow access to these variables from the threads.

StreamArray* vtkStreamer::GetStreamers | ( |  | ) | `[inline, protected]`

| These methods were added to allow access to these variables from the threads. Definition at line 322 of file vtkStreamer.h.

void vtkStreamer::InitializeThreadedIntegrate | ( |  | ) | `[protected]`

## Friends And Related Function Documentation

friend class StreamArray`[friend]`

| Definition at line 250 of file vtkStreamer.h.

## Member Data Documentation

int vtkStreamer::StartFrom`[protected]`

| Definition at line 219 of file vtkStreamer.h.

vtkIdType vtkStreamer::StartCell`[protected]`

| Definition at line 222 of file vtkStreamer.h.

int vtkStreamer::StartSubId`[protected]`

| Definition at line 223 of file vtkStreamer.h.

float vtkStreamer::StartPCoords[3]`[protected]`

| Definition at line 224 of file vtkStreamer.h.

float vtkStreamer::StartPosition[3]`[protected]`

| Definition at line 227 of file vtkStreamer.h.

StreamArray* vtkStreamer::Streamers`[protected]`

| Definition at line 284 of file vtkStreamer.h.

vtkIdType vtkStreamer::NumberOfStreamers`[protected]`

| Definition at line 285 of file vtkStreamer.h.

float vtkStreamer::MaximumPropagationTime`[protected]`

| Definition at line 288 of file vtkStreamer.h.

int vtkStreamer::IntegrationDirection`[protected]`

| Definition at line 291 of file vtkStreamer.h. Referenced by GetIntegrationDirectionAsString().

float vtkStreamer::IntegrationStepLength`[protected]`

| Definition at line 294 of file vtkStreamer.h.

int vtkStreamer::Vorticity`[protected]`

| Definition at line 297 of file vtkStreamer.h.

float vtkStreamer::TerminalSpeed`[protected]`

| Definition at line 300 of file vtkStreamer.h.

int vtkStreamer::SpeedScalars`[protected]`

| Definition at line 303 of file vtkStreamer.h.

int vtkStreamer::OrientationScalars`[protected]`

| Definition at line 306 of file vtkStreamer.h.

vtkInitialValueProblemSolver* vtkStreamer::Integrator`[protected]`

| Definition at line 309 of file vtkStreamer.h.

float vtkStreamer::SavePointInterval`[protected]`

| Definition at line 314 of file vtkStreamer.h.

vtkMultiThreader* vtkStreamer::Threader`[protected]`

| Definition at line 326 of file vtkStreamer.h.

int vtkStreamer::NumberOfThreads`[protected]`

| Definition at line 327 of file vtkStreamer.h.

The documentation for this class was generated from the following file:

- Graphics/vtkStreamer.h